#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdint.h>
#include <openssl/md5.h>
#include <glib.h>
#include "common.h"

void proceed_search(unsigned char *blocks, t_ihv *ihvs)
{
    MD5_CTX c;
    MD5_Init(&c);
    c.A = ihvs[0].a;
    c.B = ihvs[0].b;
    c.C = ihvs[0].c;
    c.D = ihvs[0].d;
    MD5_Update(&c, blocks, 64);
    printf("A,B,C,D:    %08x %08x %08x %08x (x,y %08x,%08x)\n",
	    c.A, c.B, c.C, c.D, c.A, c.C - c.D);
    printf("byte order: %08x %08x %08x %08x\n",
	    swapu32(c.A), swapu32(c.B), swapu32(c.C), swapu32(c.D));
}

int main(int argc, char **argv)
{
    if (argc != 2)
	fprintf(stderr, "Usage: play <state>\n"), exit(1);
    unsigned char *blocks;
    t_ihv *ihvs;
    read_blocks_ihvs(&blocks, &ihvs, argv[1]);
    proceed_search(blocks, ihvs);
    return 0;
}
